/*
Taken from "ifstatus" by David Curry, Purdue University
*/

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <stdio.h>
#include <errno.h>

extern FILE *mail, *log ;

int checkInterfaces(int msg) {
  int n, s, mystatus = 0 ;
  char cbuf[1024];
  struct ifconf ifc;
  struct ifreq ifr, *ifrp;

  if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) fatal("socket");

  ifc.ifc_buf = cbuf;
  ifc.ifc_len = sizeof(cbuf);

  if (ioctl(s, SIOCGIFCONF, (char *) &ifc) < 0) fatal("ioctl: SIOCGIFCONF");

  close(s);
  ifrp = ifc.ifc_req;

  for (n = ifc.ifc_len / sizeof(struct ifreq); n > 0; n--, ifrp++) {
    if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) fatal("socket");

    strcpy(ifr.ifr_name, ifrp->ifr_name);

    if (ioctl(s, SIOCGIFFLAGS, (char *) &ifr) < 0) fatal("ioctl: SIOCGIFFLAGS");

    if (ifr.ifr_flags & IFF_PROMISC) {
      if (msg) {
        if (log) fprintf(log,"WARNING: INTERFACE %s IS IN PROMISCUOUS MODE.\n", ifr.ifr_name);
        if (mail) fprintf(mail,"WARNING: INTERFACE %s IS IN PROMISCUOUS MODE.\n", ifr.ifr_name);
      }
      mystatus |= 2 ;
    }

    if (ifr.ifr_flags & IFF_DEBUG) {
      if (msg) {
        if (log) fprintf(log,"WARNING: INTERFACE %s IS IN DEBUG MODE.\n", ifr.ifr_name);
        if (mail) fprintf(mail,"WARNING: INTERFACE %s IS IN DEBUG MODE.\n", ifr.ifr_name);
      }
      mystatus |= 4 ;
    }
    close(s);
  }
  return (mystatus) ;
}

fatal(char *s1) {
  perror(s1);
  exit(1);
}

